-------------------------------------------------------------------------------
-- Product Note PN122
-- VHDL module used in the 'RTDS MMC SFP' project
-- Copyright imperix ltd, 2024
-- dev@imperix.ch
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity RTDS_serial_to_parallel_B is
    Generic(
        N : natural := 20
    );
    Port(
        clk : IN std_logic;
        nreset : IN std_logic;

        Nsm : IN unsigned(4 downto 0);

        IN_S_AXIS_tdata : IN std_logic_vector(31 downto 0);
        IN_S_AXIS_tvalid : IN std_logic;
        IN_S_AXIS_tlast : IN std_logic;

        cap_v_sm_01_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_02_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_03_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_04_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_05_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_06_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_07_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_08_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_09_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_10_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_11_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_12_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_13_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_14_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_15_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_16_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_17_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_18_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_19_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_20_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');

        cap_v_sm_01_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_02_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_03_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_04_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_05_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_06_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_07_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_08_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_09_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_10_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_11_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_12_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_13_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_14_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_15_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_16_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_17_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_18_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_19_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_20_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');

        cap_v_sm_01_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_02_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_03_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_04_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_05_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_06_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_07_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_08_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_09_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_10_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_11_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_12_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_13_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_14_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_15_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_16_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_17_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_18_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_19_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_20_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');

        cap_v_sm_01_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_02_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_03_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_04_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_05_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_06_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_07_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_08_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_09_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_10_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_11_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_12_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_13_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_14_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_15_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_16_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_17_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_18_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_19_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_20_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');

        cap_v_sm_01_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_02_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_03_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_04_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_05_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_06_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_07_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_08_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_09_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_10_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_11_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_12_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_13_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_14_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_15_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_16_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_17_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_18_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_19_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_20_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');

        cap_v_sm_01_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_02_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_03_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_04_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_05_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_06_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_07_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_08_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_09_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_10_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_11_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_12_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_13_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_14_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_15_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_16_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_17_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_18_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_19_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        cap_v_sm_20_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');

        out_valid : OUT std_logic := '0'
    );
end RTDS_serial_to_parallel_B;

architecture Behavioral of RTDS_serial_to_parallel_B is

    signal w_IN_S_AXIS_tready : std_logic;

    signal transmission_valid : std_logic := '0';
    signal transmission_valid_last : std_logic := '0';
    signal transmission_valid_last_ff : std_logic := '0';

    type branch_state is (BRANCH_1, BRANCH_2, BRANCH_3, BRANCH_4, BRANCH_5, BRANCH_6);
    signal current_branch : branch_state := BRANCH_1;
    signal current_index : unsigned(7 downto 0) := x"00";

    type custom_array is array (0 to N*6-1) of std_logic_vector(31 downto 0);
    signal vals_stage1 : custom_array := (others => (others => '0'));
    signal vals_stage2 : custom_array := (others => (others => '0'));
    signal vals_updated : std_logic_vector(N*6-1 downto 0) := (others => '0');

    signal offset : unsigned(7 downto 0) := x"00";
    signal address : unsigned(7 downto 0) := x"00";

    -- interface
    ATTRIBUTE X_INTERFACE_INFO : STRING;
    ATTRIBUTE X_INTERFACE_PARAMETER : STRING;

    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_01_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_000";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_02_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_001";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_03_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_002";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_04_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_003";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_05_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_004";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_06_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_005";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_07_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_006";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_08_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_007";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_09_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_008";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_10_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_009";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_11_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_010";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_12_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_011";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_13_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_012";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_14_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_013";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_15_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_014";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_16_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_015";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_17_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_016";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_18_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_017";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_19_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_018";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_20_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_019";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_01_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_020";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_02_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_021";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_03_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_022";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_04_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_023";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_05_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_024";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_06_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_025";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_07_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_026";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_08_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_027";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_09_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_028";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_10_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_029";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_11_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_030";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_12_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_031";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_13_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_032";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_14_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_033";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_15_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_034";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_16_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_035";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_17_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_036";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_18_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_037";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_19_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_038";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_20_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_039";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_01_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_040";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_02_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_041";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_03_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_042";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_04_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_043";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_05_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_044";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_06_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_045";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_07_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_046";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_08_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_047";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_09_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_048";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_10_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_049";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_11_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_050";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_12_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_051";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_13_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_052";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_14_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_053";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_15_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_054";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_16_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_055";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_17_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_056";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_18_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_057";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_19_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_058";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_20_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_059";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_01_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_060";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_02_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_061";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_03_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_062";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_04_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_063";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_05_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_064";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_06_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_065";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_07_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_066";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_08_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_067";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_09_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_068";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_10_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_069";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_11_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_070";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_12_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_071";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_13_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_072";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_14_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_073";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_15_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_074";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_16_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_075";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_17_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_076";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_18_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_077";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_19_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_078";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_20_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_079";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_01_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_080";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_02_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_081";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_03_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_082";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_04_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_083";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_05_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_084";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_06_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_085";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_07_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_086";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_08_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_087";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_09_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_088";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_10_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_089";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_11_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_090";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_12_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_091";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_13_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_092";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_14_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_093";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_15_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_094";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_16_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_095";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_17_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_096";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_18_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_097";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_19_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_098";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_20_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_099";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_01_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_100";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_02_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_101";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_03_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_102";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_04_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_103";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_05_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_104";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_06_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_105";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_07_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_106";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_08_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_107";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_09_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_108";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_10_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_109";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_11_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_110";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_12_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_111";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_13_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_112";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_14_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_113";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_15_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_114";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_16_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_115";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_17_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_116";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_18_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_117";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_19_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_118";
    ATTRIBUTE X_INTERFACE_INFO of cap_v_sm_20_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_119";

    ATTRIBUTE X_INTERFACE_INFO of clk: SIGNAL is "xilinx.com:signal:clock:1.0 clk CLK";
    ATTRIBUTE X_INTERFACE_PARAMETER of clk: SIGNAL is "FREQ_HZ 250000000, ASSOCIATED_BUSIF signals_out:IN_S_AXIS";

begin

    -- always accepts data
    w_IN_S_AXIS_tready <= '1';

    -- transmission is valid if valid and ready
    transmission_valid <= '1' when (IN_S_AXIS_tvalid = '1') and (w_IN_S_AXIS_tready = '1') else '0';
    transmission_valid_last <= '1' when (transmission_valid = '1') and (IN_S_AXIS_tlast = '1') else '0';

    -- update current_index
    process(clk)
    begin
        if rising_edge(clk) then
            if (nreset = '0') or (transmission_valid_last = '1') then
                current_branch <= BRANCH_1;
                current_index <= x"00";
            elsif transmission_valid = '1' then
                if current_index < Nsm-1 then
                    current_index <= current_index + 1;
                else
                    current_index <= x"00";

                    case current_branch is
                        when BRANCH_1 => current_branch <= BRANCH_2;
                        when BRANCH_2 => current_branch <= BRANCH_3;
                        when BRANCH_3 => current_branch <= BRANCH_4;
                        when BRANCH_4 => current_branch <= BRANCH_5;
                        when BRANCH_5 => current_branch <= BRANCH_6;
                        when others => current_branch <= BRANCH_1;
                    end case;
                end if;
            end if;
        end if;
    end process;

    with current_branch select offset <=
        to_unsigned(0  ,8) when BRANCH_1,
        to_unsigned(N  ,8) when BRANCH_2,
        to_unsigned(2*N,8) when BRANCH_3,
        to_unsigned(3*N,8) when BRANCH_4,
        to_unsigned(4*N,8) when BRANCH_5,
        to_unsigned(5*N,8) when BRANCH_6,
        to_unsigned(0  ,8) when others;

    address <= offset + current_index;

    process(clk)
    begin
        if rising_edge(clk) then
            if transmission_valid = '1' then
                vals_stage1(to_integer(address)) <= IN_S_AXIS_tdata;
            end if;
        end if;
    end process;

    process(clk)
    begin
        if rising_edge(clk) then

            transmission_valid_last_ff <= transmission_valid_last;
            out_valid <= '0';

            if transmission_valid_last_ff = '1' then
                out_valid <= '1';
                loop_i: for i in 0 to N*6-1 loop
                    if vals_updated(i) = '1' then
                        vals_stage2(i) <= vals_stage1(i);
                    else
                        vals_stage2(i) <= (others => '0');
                    end if;
                end loop;
            end if;
        end if;
    end process;

    -- keep track of the updated registers
    -- in order to put 0 in the non-updated ones
    process(clk)
    begin
        if rising_edge(clk) then
            if transmission_valid_last_ff = '1' then
                vals_updated <= (others => '0');
            elsif transmission_valid = '1' then
                vals_updated(to_integer(address)) <= '1';
            end if;
        end if;
    end process;

    -- output is valid just after transmission_valid_last is 1
    cap_v_sm_01_leg_1 <= vals_stage2(0)  ;
    cap_v_sm_02_leg_1 <= vals_stage2(1)  ;
    cap_v_sm_03_leg_1 <= vals_stage2(2)  ;
    cap_v_sm_04_leg_1 <= vals_stage2(3)  ;
    cap_v_sm_05_leg_1 <= vals_stage2(4)  ;
    cap_v_sm_06_leg_1 <= vals_stage2(5)  ;
    cap_v_sm_07_leg_1 <= vals_stage2(6)  ;
    cap_v_sm_08_leg_1 <= vals_stage2(7)  ;
    cap_v_sm_09_leg_1 <= vals_stage2(8)  ;
    cap_v_sm_10_leg_1 <= vals_stage2(9)  ;
    cap_v_sm_11_leg_1 <= vals_stage2(10) ;
    cap_v_sm_12_leg_1 <= vals_stage2(11) ;
    cap_v_sm_13_leg_1 <= vals_stage2(12) ;
    cap_v_sm_14_leg_1 <= vals_stage2(13) ;
    cap_v_sm_15_leg_1 <= vals_stage2(14) ;
    cap_v_sm_16_leg_1 <= vals_stage2(15) ;
    cap_v_sm_17_leg_1 <= vals_stage2(16) ;
    cap_v_sm_18_leg_1 <= vals_stage2(17) ;
    cap_v_sm_19_leg_1 <= vals_stage2(18) ;
    cap_v_sm_20_leg_1 <= vals_stage2(19) ;

    cap_v_sm_01_leg_2 <= vals_stage2(20) ;
    cap_v_sm_02_leg_2 <= vals_stage2(21) ;
    cap_v_sm_03_leg_2 <= vals_stage2(22) ;
    cap_v_sm_04_leg_2 <= vals_stage2(23) ;
    cap_v_sm_05_leg_2 <= vals_stage2(24) ;
    cap_v_sm_06_leg_2 <= vals_stage2(25) ;
    cap_v_sm_07_leg_2 <= vals_stage2(26) ;
    cap_v_sm_08_leg_2 <= vals_stage2(27) ;
    cap_v_sm_09_leg_2 <= vals_stage2(28) ;
    cap_v_sm_10_leg_2 <= vals_stage2(29) ;
    cap_v_sm_11_leg_2 <= vals_stage2(30) ;
    cap_v_sm_12_leg_2 <= vals_stage2(31) ;
    cap_v_sm_13_leg_2 <= vals_stage2(32) ;
    cap_v_sm_14_leg_2 <= vals_stage2(33) ;
    cap_v_sm_15_leg_2 <= vals_stage2(34) ;
    cap_v_sm_16_leg_2 <= vals_stage2(35) ;
    cap_v_sm_17_leg_2 <= vals_stage2(36) ;
    cap_v_sm_18_leg_2 <= vals_stage2(37) ;
    cap_v_sm_19_leg_2 <= vals_stage2(38) ;
    cap_v_sm_20_leg_2 <= vals_stage2(39) ;

    cap_v_sm_01_leg_3 <= vals_stage2(40) ;
    cap_v_sm_02_leg_3 <= vals_stage2(41) ;
    cap_v_sm_03_leg_3 <= vals_stage2(42) ;
    cap_v_sm_04_leg_3 <= vals_stage2(43) ;
    cap_v_sm_05_leg_3 <= vals_stage2(44) ;
    cap_v_sm_06_leg_3 <= vals_stage2(45) ;
    cap_v_sm_07_leg_3 <= vals_stage2(46) ;
    cap_v_sm_08_leg_3 <= vals_stage2(47) ;
    cap_v_sm_09_leg_3 <= vals_stage2(48) ;
    cap_v_sm_10_leg_3 <= vals_stage2(49) ;
    cap_v_sm_11_leg_3 <= vals_stage2(50) ;
    cap_v_sm_12_leg_3 <= vals_stage2(51) ;
    cap_v_sm_13_leg_3 <= vals_stage2(52) ;
    cap_v_sm_14_leg_3 <= vals_stage2(53) ;
    cap_v_sm_15_leg_3 <= vals_stage2(54) ;
    cap_v_sm_16_leg_3 <= vals_stage2(55) ;
    cap_v_sm_17_leg_3 <= vals_stage2(56) ;
    cap_v_sm_18_leg_3 <= vals_stage2(57) ;
    cap_v_sm_19_leg_3 <= vals_stage2(58) ;
    cap_v_sm_20_leg_3 <= vals_stage2(59) ;

    cap_v_sm_01_leg_4 <= vals_stage2(60) ;
    cap_v_sm_02_leg_4 <= vals_stage2(61) ;
    cap_v_sm_03_leg_4 <= vals_stage2(62) ;
    cap_v_sm_04_leg_4 <= vals_stage2(63) ;
    cap_v_sm_05_leg_4 <= vals_stage2(64) ;
    cap_v_sm_06_leg_4 <= vals_stage2(65) ;
    cap_v_sm_07_leg_4 <= vals_stage2(66) ;
    cap_v_sm_08_leg_4 <= vals_stage2(67) ;
    cap_v_sm_09_leg_4 <= vals_stage2(68) ;
    cap_v_sm_10_leg_4 <= vals_stage2(69) ;
    cap_v_sm_11_leg_4 <= vals_stage2(70) ;
    cap_v_sm_12_leg_4 <= vals_stage2(71) ;
    cap_v_sm_13_leg_4 <= vals_stage2(72) ;
    cap_v_sm_14_leg_4 <= vals_stage2(73) ;
    cap_v_sm_15_leg_4 <= vals_stage2(74) ;
    cap_v_sm_16_leg_4 <= vals_stage2(75) ;
    cap_v_sm_17_leg_4 <= vals_stage2(76) ;
    cap_v_sm_18_leg_4 <= vals_stage2(77) ;
    cap_v_sm_19_leg_4 <= vals_stage2(78) ;
    cap_v_sm_20_leg_4 <= vals_stage2(79) ;

    cap_v_sm_01_leg_5 <= vals_stage2(80) ;
    cap_v_sm_02_leg_5 <= vals_stage2(81) ;
    cap_v_sm_03_leg_5 <= vals_stage2(82) ;
    cap_v_sm_04_leg_5 <= vals_stage2(83) ;
    cap_v_sm_05_leg_5 <= vals_stage2(84) ;
    cap_v_sm_06_leg_5 <= vals_stage2(85) ;
    cap_v_sm_07_leg_5 <= vals_stage2(86) ;
    cap_v_sm_08_leg_5 <= vals_stage2(87) ;
    cap_v_sm_09_leg_5 <= vals_stage2(88) ;
    cap_v_sm_10_leg_5 <= vals_stage2(89) ;
    cap_v_sm_11_leg_5 <= vals_stage2(90) ;
    cap_v_sm_12_leg_5 <= vals_stage2(91) ;
    cap_v_sm_13_leg_5 <= vals_stage2(92) ;
    cap_v_sm_14_leg_5 <= vals_stage2(93) ;
    cap_v_sm_15_leg_5 <= vals_stage2(94) ;
    cap_v_sm_16_leg_5 <= vals_stage2(95) ;
    cap_v_sm_17_leg_5 <= vals_stage2(96) ;
    cap_v_sm_18_leg_5 <= vals_stage2(97) ;
    cap_v_sm_19_leg_5 <= vals_stage2(98) ;
    cap_v_sm_20_leg_5 <= vals_stage2(99) ;

    cap_v_sm_01_leg_6 <= vals_stage2(100);
    cap_v_sm_02_leg_6 <= vals_stage2(101);
    cap_v_sm_03_leg_6 <= vals_stage2(102);
    cap_v_sm_04_leg_6 <= vals_stage2(103);
    cap_v_sm_05_leg_6 <= vals_stage2(104);
    cap_v_sm_06_leg_6 <= vals_stage2(105);
    cap_v_sm_07_leg_6 <= vals_stage2(106);
    cap_v_sm_08_leg_6 <= vals_stage2(107);
    cap_v_sm_09_leg_6 <= vals_stage2(108);
    cap_v_sm_10_leg_6 <= vals_stage2(109);
    cap_v_sm_11_leg_6 <= vals_stage2(110);
    cap_v_sm_12_leg_6 <= vals_stage2(111);
    cap_v_sm_13_leg_6 <= vals_stage2(112);
    cap_v_sm_14_leg_6 <= vals_stage2(113);
    cap_v_sm_15_leg_6 <= vals_stage2(114);
    cap_v_sm_16_leg_6 <= vals_stage2(115);
    cap_v_sm_17_leg_6 <= vals_stage2(116);
    cap_v_sm_18_leg_6 <= vals_stage2(117);
    cap_v_sm_19_leg_6 <= vals_stage2(118);
    cap_v_sm_20_leg_6 <= vals_stage2(119);

end Behavioral;
