-------------------------------------------------------------------------------
-- Product Note PN122
-- VHDL module used in the 'RTDS MMC SFP' project
-- Copyright imperix ltd, 2024
-- dev@imperix.ch
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity RTDS_serial_to_parallel_C is
    Generic(
        N : natural := 20
    );
    Port(
        clk : IN std_logic;
        nreset : IN std_logic;

        Nsm : IN unsigned(4 downto 0);

        IN_S_AXIS_tdata : IN std_logic_vector(31 downto 0);
        IN_S_AXIS_tvalid : IN std_logic;
        IN_S_AXIS_tlast : IN std_logic;

        sm_02_01_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_04_03_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_06_05_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_08_07_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_10_09_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_12_11_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_14_13_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_16_15_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_18_17_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_20_19_leg_1 : OUT std_logic_vector(31 downto 0) := (others => '0');

        sm_02_01_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_04_03_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_06_05_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_08_07_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_10_09_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_12_11_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_14_13_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_16_15_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_18_17_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_20_19_leg_2 : OUT std_logic_vector(31 downto 0) := (others => '0');

        sm_02_01_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_04_03_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_06_05_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_08_07_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_10_09_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_12_11_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_14_13_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_16_15_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_18_17_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_20_19_leg_3 : OUT std_logic_vector(31 downto 0) := (others => '0');

        sm_02_01_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_04_03_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_06_05_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_08_07_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_10_09_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_12_11_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_14_13_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_16_15_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_18_17_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_20_19_leg_4 : OUT std_logic_vector(31 downto 0) := (others => '0');

        sm_02_01_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_04_03_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_06_05_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_08_07_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_10_09_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_12_11_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_14_13_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_16_15_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_18_17_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_20_19_leg_5 : OUT std_logic_vector(31 downto 0) := (others => '0');

        sm_02_01_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_04_03_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_06_05_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_08_07_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_10_09_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_12_11_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_14_13_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_16_15_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_18_17_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');
        sm_20_19_leg_6 : OUT std_logic_vector(31 downto 0) := (others => '0');

        out_valid : OUT std_logic := '0'
    );
end RTDS_serial_to_parallel_C;

architecture Behavioral of RTDS_serial_to_parallel_C is

    function rnd_even(N : natural)
        return natural is
    begin
        if N mod 2 = 0 then
            return N;
        else
            return N+1;
        end if;
    end function;

    signal w_IN_S_AXIS_tready : std_logic;

    signal transmission_valid : std_logic := '0';
    signal transmission_valid_last : std_logic := '0';
    signal transmission_valid_last_ff : std_logic := '0';

    type branch_state is (BRANCH_1, BRANCH_2, BRANCH_3, BRANCH_4, BRANCH_5, BRANCH_6);
    signal current_branch : branch_state := BRANCH_1;
    signal current_index : unsigned(7 downto 0) := x"00";

    constant N_rnd_div2 : natural := rnd_even(N)/2;
    signal Nsm_rnd_div2 : unsigned(4 downto 0);

    type custom_array is array (0 to N_rnd_div2*6-1) of std_logic_vector(31 downto 0);
    signal vals_stage1 : custom_array := (others => (others => '0'));
    signal vals_stage2 : custom_array := (others => (others => '0'));
    signal vals_updated : std_logic_vector(N_rnd_div2*6-1 downto 0) := (others => '0');

    signal offset : unsigned(7 downto 0) := x"00";
    signal address : unsigned(7 downto 0) := x"00";

    -- interface
    ATTRIBUTE X_INTERFACE_INFO : STRING;
    ATTRIBUTE X_INTERFACE_PARAMETER : STRING;

    ATTRIBUTE X_INTERFACE_INFO of sm_02_01_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_000";
    ATTRIBUTE X_INTERFACE_INFO of sm_04_03_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_001";
    ATTRIBUTE X_INTERFACE_INFO of sm_06_05_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_002";
    ATTRIBUTE X_INTERFACE_INFO of sm_08_07_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_003";
    ATTRIBUTE X_INTERFACE_INFO of sm_10_09_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_004";
    ATTRIBUTE X_INTERFACE_INFO of sm_12_11_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_005";
    ATTRIBUTE X_INTERFACE_INFO of sm_14_13_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_006";
    ATTRIBUTE X_INTERFACE_INFO of sm_16_15_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_007";
    ATTRIBUTE X_INTERFACE_INFO of sm_18_17_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_008";
    ATTRIBUTE X_INTERFACE_INFO of sm_20_19_leg_1: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_009";
    ATTRIBUTE X_INTERFACE_INFO of sm_02_01_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_010";
    ATTRIBUTE X_INTERFACE_INFO of sm_04_03_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_011";
    ATTRIBUTE X_INTERFACE_INFO of sm_06_05_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_012";
    ATTRIBUTE X_INTERFACE_INFO of sm_08_07_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_013";
    ATTRIBUTE X_INTERFACE_INFO of sm_10_09_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_014";
    ATTRIBUTE X_INTERFACE_INFO of sm_12_11_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_015";
    ATTRIBUTE X_INTERFACE_INFO of sm_14_13_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_016";
    ATTRIBUTE X_INTERFACE_INFO of sm_16_15_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_017";
    ATTRIBUTE X_INTERFACE_INFO of sm_18_17_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_018";
    ATTRIBUTE X_INTERFACE_INFO of sm_20_19_leg_2: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_019";
    ATTRIBUTE X_INTERFACE_INFO of sm_02_01_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_020";
    ATTRIBUTE X_INTERFACE_INFO of sm_04_03_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_021";
    ATTRIBUTE X_INTERFACE_INFO of sm_06_05_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_022";
    ATTRIBUTE X_INTERFACE_INFO of sm_08_07_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_023";
    ATTRIBUTE X_INTERFACE_INFO of sm_10_09_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_024";
    ATTRIBUTE X_INTERFACE_INFO of sm_12_11_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_025";
    ATTRIBUTE X_INTERFACE_INFO of sm_14_13_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_026";
    ATTRIBUTE X_INTERFACE_INFO of sm_16_15_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_027";
    ATTRIBUTE X_INTERFACE_INFO of sm_18_17_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_028";
    ATTRIBUTE X_INTERFACE_INFO of sm_20_19_leg_3: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_029";
    ATTRIBUTE X_INTERFACE_INFO of sm_02_01_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_030";
    ATTRIBUTE X_INTERFACE_INFO of sm_04_03_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_031";
    ATTRIBUTE X_INTERFACE_INFO of sm_06_05_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_032";
    ATTRIBUTE X_INTERFACE_INFO of sm_08_07_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_033";
    ATTRIBUTE X_INTERFACE_INFO of sm_10_09_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_034";
    ATTRIBUTE X_INTERFACE_INFO of sm_12_11_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_035";
    ATTRIBUTE X_INTERFACE_INFO of sm_14_13_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_036";
    ATTRIBUTE X_INTERFACE_INFO of sm_16_15_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_037";
    ATTRIBUTE X_INTERFACE_INFO of sm_18_17_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_038";
    ATTRIBUTE X_INTERFACE_INFO of sm_20_19_leg_4: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_039";
    ATTRIBUTE X_INTERFACE_INFO of sm_02_01_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_040";
    ATTRIBUTE X_INTERFACE_INFO of sm_04_03_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_041";
    ATTRIBUTE X_INTERFACE_INFO of sm_06_05_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_042";
    ATTRIBUTE X_INTERFACE_INFO of sm_08_07_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_043";
    ATTRIBUTE X_INTERFACE_INFO of sm_10_09_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_044";
    ATTRIBUTE X_INTERFACE_INFO of sm_12_11_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_045";
    ATTRIBUTE X_INTERFACE_INFO of sm_14_13_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_046";
    ATTRIBUTE X_INTERFACE_INFO of sm_16_15_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_047";
    ATTRIBUTE X_INTERFACE_INFO of sm_18_17_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_048";
    ATTRIBUTE X_INTERFACE_INFO of sm_20_19_leg_5: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_049";
    ATTRIBUTE X_INTERFACE_INFO of sm_02_01_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_050";
    ATTRIBUTE X_INTERFACE_INFO of sm_04_03_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_051";
    ATTRIBUTE X_INTERFACE_INFO of sm_06_05_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_052";
    ATTRIBUTE X_INTERFACE_INFO of sm_08_07_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_053";
    ATTRIBUTE X_INTERFACE_INFO of sm_10_09_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_054";
    ATTRIBUTE X_INTERFACE_INFO of sm_12_11_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_055";
    ATTRIBUTE X_INTERFACE_INFO of sm_14_13_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_056";
    ATTRIBUTE X_INTERFACE_INFO of sm_16_15_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_057";
    ATTRIBUTE X_INTERFACE_INFO of sm_18_17_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_058";
    ATTRIBUTE X_INTERFACE_INFO of sm_20_19_leg_6: SIGNAL is "imperix.ch:user:CUSTOM_BUS:1.0 signals_out port_059";

    ATTRIBUTE X_INTERFACE_INFO of clk: SIGNAL is "xilinx.com:signal:clock:1.0 clk CLK";
    ATTRIBUTE X_INTERFACE_PARAMETER of clk: SIGNAL is "FREQ_HZ 250000000, ASSOCIATED_BUSIF signals_out:IN_S_AXIS";

begin

    -- update counter limit = ceil(N/2)
    Nsm_rnd_div2 <= shift_right(Nsm+1, 1);

    -- always accepts data
    w_IN_S_AXIS_tready <= '1';

    -- transmission is valid if valid and ready
    transmission_valid <= '1' when (IN_S_AXIS_tvalid = '1') and (w_IN_S_AXIS_tready = '1') else '0';
    transmission_valid_last <= '1' when (transmission_valid = '1') and (IN_S_AXIS_tlast = '1') else '0';

    -- update current_index
    process(clk)
    begin
        if rising_edge(clk) then
            if (nreset = '0') or (transmission_valid_last = '1') then
                current_branch <= BRANCH_1;
                current_index <= x"00";
            elsif transmission_valid = '1' then
                if current_index < Nsm_rnd_div2-1 then
                    current_index <= current_index + 1;
                else
                    current_index <= x"00";

                    case current_branch is
                        when BRANCH_1 => current_branch <= BRANCH_2;
                        when BRANCH_2 => current_branch <= BRANCH_3;
                        when BRANCH_3 => current_branch <= BRANCH_4;
                        when BRANCH_4 => current_branch <= BRANCH_5;
                        when BRANCH_5 => current_branch <= BRANCH_6;
                        when others => current_branch <= BRANCH_1;
                    end case;
                end if;
            end if;
        end if;
    end process;

    with current_branch select offset <=
        to_unsigned(0*N_rnd_div2,8) when BRANCH_1,
        to_unsigned(1*N_rnd_div2,8) when BRANCH_2,
        to_unsigned(2*N_rnd_div2,8) when BRANCH_3,
        to_unsigned(3*N_rnd_div2,8) when BRANCH_4,
        to_unsigned(4*N_rnd_div2,8) when BRANCH_5,
        to_unsigned(5*N_rnd_div2,8) when BRANCH_6,
        to_unsigned(0*N_rnd_div2,8) when others;

    address <= offset + current_index;

    process(clk)
    begin
        if rising_edge(clk) then
            if transmission_valid = '1' then
                vals_stage1(to_integer(address)) <= IN_S_AXIS_tdata;
            end if;
        end if;
    end process;

    process(clk)
    begin
        if rising_edge(clk) then

            transmission_valid_last_ff <= transmission_valid_last;
            out_valid <= '0';

            if transmission_valid_last_ff = '1' then
                out_valid <= '1';
                loop_i: for i in 0 to N_rnd_div2*6-1 loop
                    if vals_updated(i) = '1' then
                        vals_stage2(i) <= vals_stage1(i);
                    else
                        vals_stage2(i) <= (others => '0');
                    end if;
                end loop;
            end if;
        end if;
    end process;

    -- keep track of the updated registers
    -- in order to put 0 in the non-updated ones
    process(clk)
    begin
        if rising_edge(clk) then
            if transmission_valid_last_ff = '1' then
                vals_updated <= (others => '0');
            elsif transmission_valid = '1' then
                vals_updated(to_integer(address)) <= '1';
            end if;
        end if;
    end process;

    -- output is valid just after transmission_valid_last is 1
    sm_02_01_leg_1 <= vals_stage2(0) ;
    sm_04_03_leg_1 <= vals_stage2(1) ;
    sm_06_05_leg_1 <= vals_stage2(2) ;
    sm_08_07_leg_1 <= vals_stage2(3) ;
    sm_10_09_leg_1 <= vals_stage2(4) ;
    sm_12_11_leg_1 <= vals_stage2(5) ;
    sm_14_13_leg_1 <= vals_stage2(6) ;
    sm_16_15_leg_1 <= vals_stage2(7) ;
    sm_18_17_leg_1 <= vals_stage2(8) ;
    sm_20_19_leg_1 <= vals_stage2(9) ;
    sm_02_01_leg_2 <= vals_stage2(10);
    sm_04_03_leg_2 <= vals_stage2(11);
    sm_06_05_leg_2 <= vals_stage2(12);
    sm_08_07_leg_2 <= vals_stage2(13);
    sm_10_09_leg_2 <= vals_stage2(14);
    sm_12_11_leg_2 <= vals_stage2(15);
    sm_14_13_leg_2 <= vals_stage2(16);
    sm_16_15_leg_2 <= vals_stage2(17);
    sm_18_17_leg_2 <= vals_stage2(18);
    sm_20_19_leg_2 <= vals_stage2(19);
    sm_02_01_leg_3 <= vals_stage2(20);
    sm_04_03_leg_3 <= vals_stage2(21);
    sm_06_05_leg_3 <= vals_stage2(22);
    sm_08_07_leg_3 <= vals_stage2(23);
    sm_10_09_leg_3 <= vals_stage2(24);
    sm_12_11_leg_3 <= vals_stage2(25);
    sm_14_13_leg_3 <= vals_stage2(26);
    sm_16_15_leg_3 <= vals_stage2(27);
    sm_18_17_leg_3 <= vals_stage2(28);
    sm_20_19_leg_3 <= vals_stage2(29);
    sm_02_01_leg_4 <= vals_stage2(30);
    sm_04_03_leg_4 <= vals_stage2(31);
    sm_06_05_leg_4 <= vals_stage2(32);
    sm_08_07_leg_4 <= vals_stage2(33);
    sm_10_09_leg_4 <= vals_stage2(34);
    sm_12_11_leg_4 <= vals_stage2(35);
    sm_14_13_leg_4 <= vals_stage2(36);
    sm_16_15_leg_4 <= vals_stage2(37);
    sm_18_17_leg_4 <= vals_stage2(38);
    sm_20_19_leg_4 <= vals_stage2(39);
    sm_02_01_leg_5 <= vals_stage2(40);
    sm_04_03_leg_5 <= vals_stage2(41);
    sm_06_05_leg_5 <= vals_stage2(42);
    sm_08_07_leg_5 <= vals_stage2(43);
    sm_10_09_leg_5 <= vals_stage2(44);
    sm_12_11_leg_5 <= vals_stage2(45);
    sm_14_13_leg_5 <= vals_stage2(46);
    sm_16_15_leg_5 <= vals_stage2(47);
    sm_18_17_leg_5 <= vals_stage2(48);
    sm_20_19_leg_5 <= vals_stage2(49);
    sm_02_01_leg_6 <= vals_stage2(50);
    sm_04_03_leg_6 <= vals_stage2(51);
    sm_06_05_leg_6 <= vals_stage2(52);
    sm_08_07_leg_6 <= vals_stage2(53);
    sm_10_09_leg_6 <= vals_stage2(54);
    sm_12_11_leg_6 <= vals_stage2(55);
    sm_14_13_leg_6 <= vals_stage2(56);
    sm_16_15_leg_6 <= vals_stage2(57);
    sm_18_17_leg_6 <= vals_stage2(58);
    sm_20_19_leg_6 <= vals_stage2(59);

end Behavioral;
