-------------------------------------------------------------------------------
-- Product Note PN122
-- VHDL module used in the 'RTDS MMC SFP' project
-- Copyright imperix ltd, 2024
-- dev@imperix.ch
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity RTDS_trigger is
    Port(
        clk : IN std_logic;
        period : IN unsigned(15 downto 0);
        trigger : OUT std_logic
    );
end RTDS_trigger;

architecture Behavioral of RTDS_trigger is

    signal counter : unsigned(15 downto 0) := x"0000";

begin

    trigger <= '1' when (period /= 0) and (counter = period-1) else '0';

    process(clk) begin
        if rising_edge(clk) then
            if (period = 0) or (counter >= period-1) then
                counter <= x"0000";
            else
                counter <= counter+1;
            end if;
        end if;
    end process;

end Behavioral;
