-------------------------------------------------------------------------------
-- Product Note PN122
-- VHDL module used in the 'RTDS MMC SFP' project
-- Copyright imperix ltd, 2024
-- dev@imperix.ch
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity gen_complementary is
    Generic(
        N : natural := 4
    );
    Port(
        enable_pwm : IN std_logic;
        pwm_in : IN std_logic_vector(N*6-1 downto 0);
        pwm_out : OUT std_logic_vector(2*N*6-1 downto 0)
    );
end gen_complementary;

architecture Behavioral of gen_complementary is

begin

    generate_firing: for i in 0 to N*6-1 generate
        pwm_out(2*i+1 downto 2*i) <= not pwm_in(i) & pwm_in(i) when enable_pwm = '1' else "00";
    end generate;

end Behavioral;
